<?php
// ---------------------------------------------------------------------------
// $Id: TitleAction.class.php,v 1.5 2004/12/19 19:23:20 dankert Exp $
// ---------------------------------------------------------------------------
// OpenRat Content Management System
// Copyright (C) 2002 Jan Dankert, jandankert@jandankert.de
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// $Log: TitleAction.class.php,v $
// Revision 1.5  2004/12/19 19:23:20  dankert
// Link auf Profil korrigiert
//
// Revision 1.4  2004/12/15 23:24:23  dankert
// Html::url()-Parameter angepasst
//
// Revision 1.3  2004/11/10 22:40:32  dankert
// Benutzen der Session-Klasse
//
// Revision 1.2  2004/05/02 14:49:37  dankert
// Einf?gen package-name (@package)
//
// Revision 1.1  2004/04/24 15:14:52  dankert
// Initiale Version
//
// ---------------------------------------------------------------------------


/**
 * Actionklasse zum Anzeigen der Titelleiste
 * @author $Author: dankert $
 * @version $Revision: 1.5 $
 * @package openrat.actions
 */
class TitleAction extends Action
{
	/**
	 * Standard-Subaction
	 * @type String
	 */
	var $defaultSubAction = 'show';


	/**
	 * Fuellen der Variablen und Anzeigen der Titelleiste
	 */
	function show()
	{
		$this->setTemplateVar('css_body_class','title');

		$db = Session::getDatabase();
		$this->setTemplateVar('dbid'  ,$db->id              ); 
		$this->setTemplateVar('dbname',$db->conf['comment'] );

		$user = Session::getUser();		
		$this->setTemplateVar('username'    ,$user->name    );
		$this->setTemplateVar('userfullname',$user->fullname);
		
		// Urls zum Benutzerprofil und zum Abmelden
		$this->setTemplateVar('profile_url',Html::url( 'profile' ));
		$this->setTemplateVar('logout_url' ,Html::url( 'index','logout'  ));
		
		$this->setTemplateVar('css_body_class','title');
		$this->forward( 'title' );
	}
}

?>